#				PARAMETROI PEIRAMATOS

set left_nodes 5
set right_nodes 5
set SOURCES_PER_NODE_left 5
set SOURCES_PER_NODE_right 5

set AccessBW 15Mbps
set AccessDelay 0.02

#UDP agent packet size
set UDPpktsize 1500

#########################################################################################################
#			DHMIOURGIA THS TOPOLOGIAS TOU DIKTYOY

for {set i 0} {$i <$left_nodes} {incr i} {
	for {set j 0} {$j <$no_of_links} {incr j} {
		set node_left($j,$i) [$ns node]
	}
}

for {set i 0} {$i <$right_nodes} {incr i} {
	for {set j 0} {$j <$no_of_links} {incr j} {
		set node_right($j,$i) [$ns node]
	}
}

proc create_topology {node1 node2 link} {
global ns left_nodes right_nodes AccessBW AccessDelay node_left node_right
	for {set i 0} {$i <$left_nodes} {incr i} {
		$ns simplex-link $node1 $node_left($link,$i) $AccessBW $AccessDelay DropTail
		$ns simplex-link $node_left($link,$i) $node1 $AccessBW $AccessDelay DropTail

		set qleft1($link,$i) [[$ns link $node1 $node_left($link,$i)] queue]
		$qleft1($link,$i) set limit_ 1000

		set qleft2($link,$i) [[$ns link $node_left($link,$i) $node1] queue]
		$qleft2($link,$i) set limit_ 1000
	}

	for {set i 0} {$i <$right_nodes} {incr i} {
		$ns simplex-link $node2 $node_right($link,$i) $AccessBW $AccessDelay DropTail
		$ns simplex-link $node_right($link,$i) $node2 $AccessBW $AccessDelay DropTail

		set qright1($link,$i) [[$ns link $node2 $node_right($link,$i)] queue]
		$qright1($link,$i) set limit_ 1000

		set qright2($link,$i) [[$ns link $node_right($link,$i) $node2] queue]
		$qright2($link,$i) set limit_ 1000
	}
}


#########################################################################################
#			KOINES SYNARTHSEIS KAI KATANOMES

# RV for constructing Gaussian distribution...
set rvuGauss [new RandomVariable/Uniform]
$rvuGauss set min_ 0
$rvuGauss set max_ 1

# returns a value with a Gaussian distribution of "mean" and "variance"
proc Gaussian {mean variance} {
	global rvuGauss
	set p1 [$rvuGauss value]
	set p2 [$rvuGauss value]
	set gau [expr $mean + $variance * sqrt(-2.0*log($p1)) * cos($p2*2.0*3.1415927)]
	return $gau
}

# RV for TCP/UDP selection
set rvuTCPUDP [new RandomVariable/Uniform]
$rvuTCPUDP set min_ 0
$rvuTCPUDP set max_ 1
set PER_TCP 0.85

#RV for packet size
for {set i 0} {$i <8} {incr i} {
	set rvupacket_size($i) [new RandomVariable/Uniform]
	$rvupacket_size($i) set min_ 0
	$rvupacket_size($i) set max_ 0.5

}

# RandomVariable for selecting sink
set rvSINK [new RNG]


#			YPOLOGISMOS THS LOG_NORMAL KATANOMHS
proc Lognormal_m {mean variance} {
	set mean_2 pow($mean,2)
	set logos [expr $variance/$mean_2]
	set sigma_2 log(1+$logos)
	set diafora [expr $sigma_2/2]
	set m [expr log($mean)-$diafora]
	return $m
}

proc Lognormal_s2 {mean variance} {
	set mean_2 pow($mean,2)
	set logos [expr $variance/$mean_2]
	set sigma_2 log(1+$logos)
	return $sigma_2
}

##########################SMTP #################################################################
proc smtp_traffic {source_node node source sink_node START_TIME duration_TIME_SMTP finish_time flowid tcp_rate udp_rate TCPwindow} {
	global ns rvuTCPUDP PER_TCP MBS_SMTP MPS_SMTP MIT_SMTP SHAPE_SMTP UDPpktsize rveplus_SMTP rvupacket_size

	set time $START_TIME
	set time2 $finish_time
	if {[$rvuTCPUDP value] <= $PER_TCP} {
		set SMTP_TCP_agent($node,$source) [new Agent/TCP]

		$ns attach-agent $source_node $SMTP_TCP_agent($node,$source)
		set pkt [$rvupacket_size(0) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		$SMTP_TCP_agent($node,$source) set packetSize_ $pktsize
		$SMTP_TCP_agent($node,$source) set window_ $TCPwindow
		$SMTP_TCP_agent($node,$source) classify 0
		$SMTP_TCP_agent($node,$source) set fid_ 1
		set SMTP_TCP_sink($node,$source) [new Agent/TCPSink]

		$ns attach-agent $sink_node $SMTP_TCP_sink($node,$source)
		set SMTP_TCP_source($node,$source) [new Application/FTP]
		$SMTP_TCP_source($node,$source) attach-agent $SMTP_TCP_agent($node,$source)
		$ns connect $SMTP_TCP_agent($node,$source) $SMTP_TCP_sink($node,$source)
		$SMTP_TCP_agent($node,$source) set_pkttype 54
		while {$time <$finish_time} {
			$ns at $time "$SMTP_TCP_source($node,$source) send [expr $tcp_rate*$duration_TIME_SMTP/1000]"
			set time [expr $time+$duration_TIME_SMTP/1000]
			set time [expr $time+[$rveplus_SMTP value]]
		}

		$ns at [expr $time2+30.0] "$ns detach-agent $source_node $SMTP_TCP_agent($node,$source)"
		$ns at [expr $time2+30.0] "$ns detach-agent $sink_node $SMTP_TCP_sink($node,$source)"
		$ns at [expr $time2+35.0] "$SMTP_TCP_sink($node,$source) reset"
		$ns at [expr $time2+35.0] "$SMTP_TCP_agent($node,$source) reset"
	} else {
		set SMTP_UDP_agent($node,$source) [new Agent/UDP]

		$ns attach-agent $source_node $SMTP_UDP_agent($node,$source)
		$SMTP_UDP_agent($node,$source) set packetSize_ $UDPpktsize
		$SMTP_UDP_agent($node,$source) classify 0
		$SMTP_UDP_agent($node,$source) set fid_ 1
		set SMTP_UDP_sink($node,$source) [new Agent/UDP]

		$ns attach-agent $sink_node $SMTP_UDP_sink($node,$source)
		set pkt [$rvupacket_size(1) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		set SMTP_UDP_source($node,$source) [new Application/Traffic/Pareto smtp $pktsize]
		$SMTP_UDP_source($node,$source) attach-agent $SMTP_UDP_agent($node,$source)
		$SMTP_UDP_source($node,$source) set burst_time_ $MBS_SMTP
		$SMTP_UDP_source($node,$source) set idle_time_ $MIT_SMTP
		$SMTP_UDP_source($node,$source) set rate_ $udp_rate
		$SMTP_UDP_source($node,$source) set shape_ $SHAPE_SMTP
		$ns connect $SMTP_UDP_agent($node,$source) $SMTP_UDP_sink($node,$source)
		while {$time <$finish_time} {
			set fin_time [expr $time+$duration_TIME_SMTP/1000]
			$ns at $time "$SMTP_UDP_source($node,$source) start"
			$ns at $fin_time "$SMTP_UDP_source($node,$source) stop"
			set time [expr $fin_time+[$rveplus_SMTP value]]
		}

		$ns at [expr $time2+30.0] "$ns detach-agent $source_node $SMTP_UDP_agent($node,$source)"

		$ns at [expr $time2+30.0] "$ns detach-agent $sink_node $SMTP_UDP_sink($node,$source)"
		$ns at [expr $time2+35.0] "delete $SMTP_UDP_sink($node,$source)"
		$ns at [expr $time2+35.0] "delete $SMTP_UDP_agent($node,$source)"
	}
}

proc create_smtp_traffic {START_TIME STOP_TIME rate_TCP rate_UDP link TCPwindow} {
	global ns node_left node_right SOURCES_PER_NODE_left SOURCES_PER_NODE_right left_nodes right_nodes rvSINK rvuGauss MNB_SMTP VAR_MNB_SMTP rveSINKSMTP

	set MDT_SMTP [expr (($MNB_SMTP*8*1000)/($rate_UDP))]
#	puts "MDT_SMTP: $MDT_SMTP"
	#variance of duration of transmission
	set VAR_SMTP [expr ($VAR_MNB_SMTP*8*1000)/$rate_UDP]
	set M_SMTP [expr ["Lognormal_m" $MDT_SMTP $VAR_SMTP]]
	set Sigma_2_SMTP [expr ["Lognormal_s2" $MDT_SMTP $VAR_SMTP]]

	for {set k 0} {$k<= $left_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_left-1} {incr s} {
			set noSink [expr round([$rveSINKSMTP value])]
			for {set si 0} {$si<=$noSink-1} {incr si} {
				set time [expr $START_TIME+[$rvuGauss value]]
				while {$time <= $STOP_TIME} {
					#calculates duration in ms
					set duration [expr exp(["Gaussian" $M_SMTP $Sigma_2_SMTP])]
					set x [$rvSINK integer $right_nodes]
					set finish_time [expr $time+5000.0]
					if {$finish_time>$STOP_TIME} {
						set finish_time $STOP_TIME
					}
					$ns at $time "smtp_traffic $node_left($link,$k) $k $s $node_right($link,$x) $time $duration $finish_time 1 $rate_TCP $rate_UDP $TCPwindow"
					set time [expr $finish_time+[$rvuGauss value]]
				}
			}
		}
	}

	for {set k $left_nodes} {$k<= $left_nodes+$right_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_right-1} {incr s} {
			set noSink [expr round([$rveSINKSMTP value])]
			for {set si 0} {$si<=$noSink-1} {incr si} {
				set time [expr $START_TIME+[$rvuGauss value]]
				while {$time <= $STOP_TIME} {
					#calculates duration in ms
					set duration [expr exp(["Gaussian" $M_SMTP $Sigma_2_SMTP])]
					set x [$rvSINK integer $left_nodes]
					set new_node [expr $k-$left_nodes]
					set finish_time [expr $time+5000.0]
					if {$finish_time>$STOP_TIME} {
						set finish_time $STOP_TIME
					}
					$ns at $time "smtp_traffic $node_right($link,$new_node) $k $s $node_left($link,$x) $time $duration $finish_time 1 $rate_TCP $rate_UDP $TCPwindow"
					set time [expr $finish_time+[$rvuGauss value]]
				}
			}
		}
	}
}

############################TELNET ##########################################################
proc telnet_traffic {source_node node source sink_node START_TIME duration_TIME_TELNET flowid MR_TELNET MR_TELNET_Pareto TCPwindow} {
	global ns rvuTCPUDP PER_TCP MBS_TELNET MPS_TELNET MIT_TELNET SHAPE_TELNET UDPpktsize rvupacket_size

	set time $START_TIME
	set time2 [expr $time+$duration_TIME_TELNET]
	if {[$rvuTCPUDP value] <= $PER_TCP} {
		set TELNET_TCP_agent($node,$source) [new Agent/TCP]

		$ns attach-agent $source_node $TELNET_TCP_agent($node,$source)
		set pkt [$rvupacket_size(2) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		$TELNET_TCP_agent($node,$source) set packetSize_ $pktsize
		$TELNET_TCP_agent($node,$source) set window_ $TCPwindow
		$TELNET_TCP_agent($node,$source) classify 0
		$TELNET_TCP_agent($node,$source) set fid_ 1
		set TELNET_TCP_sink($node,$source) [new Agent/TCPSink]
		$TELNET_TCP_sink($node,$source) set fid_ 1

		$ns attach-agent $sink_node $TELNET_TCP_sink($node,$source)
		set TELNET_TCP_source($node,$source) [new Application/FTP]
		$TELNET_TCP_source($node,$source) attach-agent $TELNET_TCP_agent($node,$source)
		$ns connect $TELNET_TCP_agent($node,$source) $TELNET_TCP_sink($node,$source)
		$TELNET_TCP_agent($node,$source) set_pkttype 58
		$ns at $time "$TELNET_TCP_source($node,$source) send [expr $MR_TELNET*$duration_TIME_TELNET]"
		$ns at [expr $time2+30.0] "delete $TELNET_TCP_source($node,$source)"

		$ns at [expr $time2+50.0] "$ns detach-agent $source_node $TELNET_TCP_agent($node,$source)"

		$ns at [expr $time2+50.0] "$ns detach-agent $sink_node $TELNET_TCP_sink($node,$source)"
		$ns at [expr $time2+51.0] "$TELNET_TCP_sink($node,$source) reset"
		$ns at [expr $time2+51.0] "$TELNET_TCP_agent($node,$source) reset"

	} else {
		set TELNET_UDP_agent($node,$source) [new Agent/UDP]

		$ns attach-agent $source_node $TELNET_UDP_agent($node,$source)
		$TELNET_UDP_agent($node,$source) set packetSize_ $UDPpktsize
		$TELNET_UDP_agent($node,$source) classify 0
		$TELNET_UDP_agent($node,$source) set fid_ 1
		set TELNET_UDP_sink($node,$source) [new Agent/UDP]

		$ns attach-agent $sink_node $TELNET_UDP_sink($node,$source)
		set pkt [$rvupacket_size(3) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		set TELNET_UDP_source($node,$source) [new Application/Traffic/Pareto telnet $pktsize]
		$TELNET_UDP_source($node,$source) set burst_time_ $MBS_TELNET
		$TELNET_UDP_source($node,$source) set idle_time_ $MIT_TELNET
		$TELNET_UDP_source($node,$source) set rate_ $MR_TELNET_Pareto
		$TELNET_UDP_source($node,$source) set shape_ $SHAPE_TELNET
		$TELNET_UDP_source($node,$source) attach-agent $TELNET_UDP_agent($node,$source)
		$ns connect $TELNET_UDP_agent($node,$source) $TELNET_UDP_sink($node,$source)
		$ns at $time "$TELNET_UDP_source($node,$source) start"
		$ns at $time2 "$TELNET_UDP_source($node,$source) stop"
		$ns at $time2 "delete $TELNET_UDP_source($node,$source)"

		$ns at $time2 "$ns detach-agent $source_node $TELNET_UDP_agent($node,$source)"
		$ns at $time2 "delete $TELNET_UDP_agent($node,$source)"

		$ns at $time2 "$ns detach-agent $sink_node $TELNET_UDP_sink($node,$source)"
		$ns at $time2 "delete $TELNET_UDP_sink($node,$source)"
	}
}

proc create_telnet_traffic {START_TIME STOP_TIME rate_TCP rate_UDP link TCPwindow} {
	global ns node_left node_right SOURCES_PER_NODE_left SOURCES_PER_NODE_right left_nodes right_nodes M_TELNET Sigma_2_TELNET rvuGauss rvSINK rveplus_TELNET

	for {set k 0} {$k<= $left_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_left-1} {incr s} {
			set time $START_TIME
			set temp [$rvuGauss value]
			set time [expr $time+$temp]
			while {$time <= $STOP_TIME} {
				set duration [expr exp(["Gaussian" $M_TELNET $Sigma_2_TELNET])]
				set x [$rvSINK integer $right_nodes]
				$ns at $time "telnet_traffic $node_left($link,$k) $k $s $node_right($link,$x) $time $duration 2 $rate_TCP $rate_UDP $TCPwindow"
				set time [expr $time+$duration]
				set time [expr $time+[$rveplus_TELNET value]]
			}
		}
	}
	for {set k $left_nodes} {$k<= $left_nodes+$right_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_right-1} {incr s} {
			set time $START_TIME
			set temp [$rvuGauss value]
			set time [expr $time+$temp]
			while {$time <= $STOP_TIME} {
				set duration [expr exp(["Gaussian" $M_TELNET $Sigma_2_TELNET])]
				set x [$rvSINK integer $left_nodes]
				set new_node [expr $k-$left_nodes]
				$ns at $time "telnet_traffic $node_right($link,$new_node) $k $s $node_left($link,$x) $time $duration 2 $rate_TCP $rate_UDP $TCPwindow"
				set time [expr $time+$duration]
				set time [expr $time+[$rveplus_TELNET value]]
			}
		}
	}
}

############################### FTP  #########################################################
proc ftp_traffic {source_node node source sink_node START_TIME duration_TIME_FTP flowid MR_FTP MR_FTP_Pareto TCPwindow} {
	global ns rvuTCPUDP PER_TCP MBS_FTP MPS_FTP MIT_FTP SHAPE_FTP UDPpktsize rvupacket_size

	set time $START_TIME
	set time2 [expr $time+$duration_TIME_FTP]
	if {[$rvuTCPUDP value] <= $PER_TCP} {
		set FTP_TCP_agent($node,$source) [new Agent/TCP]

		$ns attach-agent $source_node $FTP_TCP_agent($node,$source)
		set pkt [$rvupacket_size(4) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		$FTP_TCP_agent($node,$source) set packetSize_ $pktsize
		$FTP_TCP_agent($node,$source) set window_ $TCPwindow
		$FTP_TCP_agent($node,$source) classify 0
		$FTP_TCP_agent($node,$source) set fid_ 1
		set FTP_TCP_sink($node,$source) [new Agent/TCPSink]
		$FTP_TCP_sink($node,$source) set fid_ 1

		$ns attach-agent $sink_node $FTP_TCP_sink($node,$source)
		set FTP_TCP_source($node,$source) [new Application/FTP]
		$FTP_TCP_source($node,$source) attach-agent $FTP_TCP_agent($node,$source)
		$ns connect $FTP_TCP_agent($node,$source) $FTP_TCP_sink($node,$source)
		$FTP_TCP_agent($node,$source) set_pkttype 56
		$ns at $time "$FTP_TCP_source($node,$source) send [expr $MR_FTP*$duration_TIME_FTP]"
		$ns at [expr $time2+30.0] "delete $FTP_TCP_source($node,$source)"

		$ns at [expr $time2+50.0] "$ns detach-agent $source_node $FTP_TCP_agent($node,$source)"

		$ns at [expr $time2+50.0] "$ns detach-agent $sink_node $FTP_TCP_sink($node,$source)"
		$ns at [expr $time2+51.0] "$FTP_TCP_sink($node,$source) reset"
		$ns at [expr $time2+51.0] "$FTP_TCP_agent($node,$source) reset"

	} else {
		set FTP_UDP_agent($node,$source) [new Agent/UDP]

		$ns attach-agent $source_node $FTP_UDP_agent($node,$source)
		$FTP_UDP_agent($node,$source) set packetSize_ $UDPpktsize
		$FTP_UDP_agent($node,$source) classify 0
		$FTP_UDP_agent($node,$source) set fid_ 1
		set FTP_UDP_sink($node,$source) [new Agent/UDP]

		$ns attach-agent $sink_node $FTP_UDP_sink($node,$source)
		set pkt [$rvupacket_size(5) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		set FTP_UDP_source($node,$source) [new Application/Traffic/Pareto ftp $pktsize]
		$FTP_UDP_source($node,$source) set burst_time_ $MBS_FTP
		$FTP_UDP_source($node,$source) set idle_time_ $MIT_FTP
		$FTP_UDP_source($node,$source) set rate_ $MR_FTP_Pareto
		$FTP_UDP_source($node,$source) set shape_ $SHAPE_FTP
		$FTP_UDP_source($node,$source) attach-agent $FTP_UDP_agent($node,$source)
		$ns connect $FTP_UDP_agent($node,$source) $FTP_UDP_sink($node,$source)
		$ns at $time "$FTP_UDP_source($node,$source) start"
		$ns at $time2 "$FTP_UDP_source($node,$source) stop"
		$ns at $time2 "delete $FTP_UDP_source($node,$source)"

		$ns at $time2 "$ns detach-agent $source_node $FTP_UDP_agent($node,$source)"
		$ns at $time2 "delete $FTP_UDP_agent($node,$source)"

		$ns at $time2 "$ns detach-agent $sink_node $FTP_UDP_sink($node,$source)"
		$ns at $time2 "delete $FTP_UDP_sink($node,$source)"
	}
}

proc create_ftp_traffic {START_TIME STOP_TIME rate_TCP rate_UDP link TCPwindow} {
	global ns node_left node_right SOURCES_PER_NODE_left SOURCES_PER_NODE_right left_nodes right_nodes rvSINK rveplus_FTP rveMDT_FTP rvuGauss

	for {set k 0} {$k<= $left_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_left-1} {incr s} {
			set time [expr $START_TIME+[$rvuGauss value]]
			while {$time <= $STOP_TIME} {
				set duration [expr [$rveMDT_FTP value]]
				set x [$rvSINK integer $right_nodes]
				$ns at $time "ftp_traffic $node_left($link,$k) $k $s $node_right($link,$x) $time $duration 3 $rate_TCP $rate_UDP $TCPwindow"
				set time [expr $time+$duration]
				set time [expr $time+[$rveplus_FTP value]]
			}
		}
	}
	for {set k $left_nodes} {$k<= $left_nodes+$right_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_right-1} {incr s} {
			set time [expr $START_TIME+[$rvuGauss value]]
			while {$time <= $STOP_TIME} {
				set duration [expr [$rveMDT_FTP value]]
				set x [$rvSINK integer $left_nodes]
				set new_node [expr $k-$left_nodes]
				$ns at $time "ftp_traffic $node_right($link,$new_node) $k $s $node_left($link,$x) $time $duration 3 $rate_TCP $rate_UDP $TCPwindow"
				set time [expr $time+$duration]
				set time [expr $time+[$rveplus_FTP value]]
			}
		}
	}
}

################################# WWW #########################################################
proc www_traffic {source_node node source sink_node START_TIME duration_TIME_WWW flowid MR_WWW MR_WWW_SupFRP TCPwindow} {
	global ns rvuTCPUDP PER_TCP MPS_WWW FRP_WWW HURST_WWW UDPpktsize rvupacket_size

	set time1 $START_TIME
	set time2 [expr $time1+$duration_TIME_WWW]
	if {[$rvuTCPUDP value] <= $PER_TCP} {
		set WWW_TCP_agent($node,$source) [new Agent/TCP]

		$ns attach-agent $source_node $WWW_TCP_agent($node,$source)
		set pkt [$rvupacket_size(6) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		$WWW_TCP_agent($node,$source) set packetSize_ $pktsize
		$WWW_TCP_agent($node,$source) set window_ $TCPwindow
		$WWW_TCP_agent($node,$source) classify 0
		$WWW_TCP_agent($node,$source) set fid_ 1
		set WWW_TCP_sink($node,$source) [new Agent/TCPSink]
		$WWW_TCP_sink($node,$source) set fid_ 1

		$ns attach-agent $sink_node $WWW_TCP_sink($node,$source)
		set WWW_TCP_source($node,$source) [new Application/FTP]
		$WWW_TCP_source($node,$source) attach-agent $WWW_TCP_agent($node,$source)
		$ns connect $WWW_TCP_agent($node,$source) $WWW_TCP_sink($node,$source)
		$WWW_TCP_agent($node,$source) set_pkttype 52
		$ns at $time1 "$WWW_TCP_source($node,$source) send [expr $MR_WWW*$duration_TIME_WWW]"
		$ns at [expr $time2+30.0] "delete $WWW_TCP_source($node,$source)"

		$ns at [expr $time2+50.0] "$ns detach-agent $source_node $WWW_TCP_agent($node,$source)"

		$ns at [expr $time2+50.0] "$ns detach-agent $sink_node $WWW_TCP_sink($node,$source)"
		$ns at [expr $time2+51.0] "$WWW_TCP_sink($node,$source) reset"
		$ns at [expr $time2+51.0] "$WWW_TCP_agent($node,$source) reset"

	} else {
		set WWW_UDP_agent($node,$source) [new Agent/UDP]

		$ns attach-agent $source_node $WWW_UDP_agent($node,$source)
		$WWW_UDP_agent($node,$source) set packetSize_ $UDPpktsize
		$WWW_UDP_agent($node,$source) classify 0
		$WWW_UDP_agent($node,$source) set fid_ 1
		set WWW_UDP_sink($node,$source) [new Agent/UDP]

		$ns attach-agent $sink_node $WWW_UDP_sink($node,$source)
		set pkt [$rvupacket_size(7) value]
		if {$pkt <= 0.02} {
			set pktsize 40
		} elseif {$pkt<=0.30} {
			set pktsize 552
		} else {
			set pktsize 1500
		}
		set WWW_UDP_source($node,$source) [new Application/Traffic/SupFRP $pktsize]
		$WWW_UDP_source($node,$source) set rate_ $MR_WWW_SupFRP
		$WWW_UDP_source($node,$source) set FRPs_ $FRP_WWW
		$WWW_UDP_source($node,$source) set hurst_ $HURST_WWW
		$WWW_UDP_source($node,$source) attach-agent $WWW_UDP_agent($node,$source)
		$ns connect $WWW_UDP_agent($node,$source) $WWW_UDP_sink($node,$source)
		$ns at $time1 "$WWW_UDP_source($node,$source) start"
		$ns at $time2 "$WWW_UDP_source($node,$source) stop"
		$ns at $time2 "delete $WWW_UDP_source($node,$source)"

		$ns at $time2 "$ns detach-agent $source_node $WWW_UDP_agent($node,$source)"
		$ns at $time2 "delete $WWW_UDP_agent($node,$source)"

		$ns at $time2 "$ns detach-agent $sink_node $WWW_UDP_sink($node,$source)"
		$ns at $time2 "delete $WWW_UDP_sink($node,$source)"
	}
}

proc create_www_traffic {START_TIME STOP_TIME rate_TCP rate_UDP link TCPwindow} {
	global ns node_left node_right SOURCES_PER_NODE_left SOURCES_PER_NODE_right left_nodes right_nodes rvSINK rvuGauss rveplus_WWW rveMDT_WWW

	for {set k 0} {$k<= $left_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_left-1} {incr s} {
			set time1 [expr $START_TIME+[$rvuGauss value]]
			while {$time1 <= $STOP_TIME} {
				set duration [expr [$rveMDT_WWW value]]
				set x [$rvSINK integer $right_nodes]
				set rate_www [expr $rate_UDP/1000]
				$ns at $time1 "www_traffic $node_left($link,$k) $k $s $node_right($link,$x) $time1 $duration 4 $rate_TCP $rate_www $TCPwindow"
				set time1 [expr $time1+$duration]
				set time1 [expr $time1+[$rveplus_WWW value]]
			}
		}
	}
	for {set k $left_nodes} {$k<= $left_nodes+$right_nodes-1} {incr k} {
		for {set s 0} {$s<=$SOURCES_PER_NODE_right-1} {incr s} {
			set time1 [expr $START_TIME+[$rvuGauss value]]
			while {$time1 <= $STOP_TIME} {
				set duration [expr [$rveMDT_WWW value]]
				set x [$rvSINK integer $left_nodes]
				set new_node [expr $k-$left_nodes]
				$ns at $time1 "www_traffic $node_right($link,$new_node) $k $s $node_left($link,$x) $time1 $duration 4 $rate_TCP $rate_www $TCPwindow"
				set time1 [expr $time1+$duration]
				set time1 [expr $time1+[$rveplus_WWW value]]
			}
		}
	}
}

####################################################################################################################
proc create_backgr_traffic {START_TIME STOP_TIME rate_TCP rate_UDP link BkboneBW BkboneDelay} {
	global ns

	set TCPpktsize 1500
	set TCPwindow [expr round((2*$BkboneBW*$BkboneDelay)/(8*$TCPpktsize))]

	$ns at $START_TIME "create_smtp_traffic $START_TIME $STOP_TIME $rate_TCP $rate_UDP $link $TCPwindow"
	$ns at $START_TIME "create_telnet_traffic $START_TIME $STOP_TIME $rate_TCP $rate_UDP $link $TCPwindow"
	$ns at $START_TIME "create_ftp_traffic $START_TIME $STOP_TIME $rate_TCP $rate_UDP $link $TCPwindow"
	$ns at $START_TIME "create_www_traffic $START_TIME $STOP_TIME $rate_TCP $rate_UDP $link $TCPwindow"

}


#######################################PARAMETROI SMTP KINHSHS###############################
#******TCP*****
#rate in Bytes/sec
#set MR_SMTP 300000
#******UDP*****
#rate in bits/sec
#set MR_SMTP_Pareto 2400000

#ON period -burst size (sec)
set MBS_SMTP 0.05
#OFF period (sec)
set MIT_SMTP 0.01
#packet size in B
set MPS_SMTP 1500

#mean number of sinks
set MNS_SMTP 5

#mean number of bytes per trasmission
set MNB_SMTP 50000
#variance of number of bytes per trasmission
set VAR_MNB_SMTP 10000

#time between transmissions
set MIAT_SMTP 50.0
#pareto shape
set SHAPE_SMTP 1.5

set rveplus_SMTP [new RandomVariable/Exponential]
$rveplus_SMTP set avg_ $MIAT_SMTP

set rveSINKSMTP [new RandomVariable/Exponential]
$rveSINKSMTP set avg_ $MNS_SMTP

#########################################################################################
#				PARAMETROI TELNET KINHSHS

#******TCP*****
#rate
#set MR_TELNET 300000
#******UDP*****
#rate
#set MR_TELNET_Pareto 2400000

#ON period -burst size (sec)
set MBS_TELNET 0.05
#OFF period (sec)
set MIT_TELNET 0.01
#packet size in B
set MPS_TELNET 500

#duration of transmission
set MDT_TELNET 10.0
#variance of duration of transmission
set VAR_TELNET 2.5
#time between transmissions
set MIAT_TELNET 500.0

#pareto shape
set SHAPE_TELNET 1.5

set M_TELNET [expr ["Lognormal_m" $MDT_TELNET $VAR_TELNET]]
set Sigma_2_TELNET [expr ["Lognormal_s2" $MDT_TELNET $VAR_TELNET]]


set rveplus_TELNET [new RandomVariable/Exponential]
$rveplus_TELNET set avg_ $MIAT_TELNET

##############################################################################################
#			PARAMETROI FTP KINHSHS

#******TCP*****
#rate in Bytes/sec
#set MR_FTP 300000
#******UDP*****
#rate in bps
#set MR_FTP_Pareto 2400000

#ON period -burst size (sec)
set MBS_FTP 0.05
#OFF period (sec)
set MIT_FTP 0.01
#packet size in B
set MPS_FTP 500

#duration of transmission
set MDT_FTP 10.0
#time between transmissions
set MIAT_FTP 130.0
#pareto shape
set SHAPE_FTP 1.5

set rveplus_FTP [new RandomVariable/Exponential]
$rveplus_FTP set avg_ $MIAT_FTP

set rveMDT_FTP [new RandomVariable/Exponential]
$rveMDT_FTP set avg_ $MDT_FTP


###################################################################################################
#			PARAMETROI WWW KINHSHS

#****TCP*****
#rate
#set MR_WWW 300000
#****UDP*****
#SupFRP rate in Kb
#set MR_WWW_SupFRP 2400

#packet size in B
set MPS_WWW 500


#duration of transmission
set MDT_WWW 10.0
#time between transmissions
set MIAT_WWW 300.0
#SupFRP FRPs
set FRP_WWW 5
#SupFRP hurst parameter
set HURST_WWW 0.92

set rveplus_WWW [new RandomVariable/Exponential]
$rveplus_WWW set avg_ $MIAT_WWW

set rveMDT_WWW [new RandomVariable/Exponential]
$rveMDT_WWW set avg_ $MDT_WWW

#######################################################################################################################