/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/* Headers */
#include "BBagent_Participants.h"
#include <iostream>

/* constructor */
BBagent_Participants::BBagent_Participants()
{
 size_of_list=0;
}




/* access functions */
int BBagent_Participants::GetSize_of_list() const
{ return size_of_list; }

void BBagent_Participants::SetSize_of_list(int nsize_of_list)
{ size_of_list=nsize_of_list; }




/*list control functions */

/*****************************************************************
 function name: BBagent_Participants::add_to_list
 return value:void
 arguments:a BBagent object
 mission:adds a new BBagent object to the list of BBagent objects.
         Also increases the variable size_of_the_list by one.
******************************************************************/
void BBagent_Participants::add_to_list(BBagent& bbgnt)
{
   bbgnt_list.push_back(bbgnt);
   size_of_list=size_of_list+1;
}


/*****************************************************************
 function name: BBagent_Participants::remove_from_list
 return value: int(0 or 1)
 arguments:a BBagent object
 mission:remove a BBagent from list of BBagent objects.
         if list becomes empty return one(1)
	  else zero(0).
******************************************************************/
int BBagent_Participants::remove_from_list(BBagent& bbgnt)
{
  list<BBagent>::iterator bbgnt_list_iter;/* an iterator for bbgnt_list */

  /*find in the list the BBagent bbgnt*/
  /*this BBagent is found according to his node id and only */
  bbgnt_list_iter = find(bbgnt_list.begin(), bbgnt_list.end() , bbgnt);

  bbgnt_list.erase(bbgnt_list_iter);/*erase him from the list*/
  size_of_list=size_of_list-1;/* reduce by one(1) the size of list */

  if(bbgnt_list.size()==0)/* if the list is now empty return one(1) */
  {return 1;}
  else{return 0;}       /* else return zero(0) */

}


/******************************************************************
 function name: BBagent_Participants::clear_list
 return value: void
 arguments:none
 mission:clears the list from all the BBagent objects
*******************************************************************/
void BBagent_Participants::clear_list()
{
  bbgnt_list.clear();/*deletes all the elements from the list */
  size_of_list=0;
  
}


/******************************************************************
 function name: BBagent_Participants::update_list
 return value:void
 arguments:a BBagent object
 mission:updates the list with the BBagent object bbgnt
 	 if the instance of bbgnt already exists ,we remove it and
	 we add the new one with the most recent information
	  else we add the new one immediately
*******************************************************************/
void BBagent_Participants::update_list(BBagent& bbgnt)
{

  list<BBagent>::iterator bbgnt_list_iter;/* an iterator for bbgnt_list */

  /*find in the list the BBagent bbgnt*/
  /*this BBagent is found according to his node id and only */
  bbgnt_list_iter = find(bbgnt_list.begin(), bbgnt_list.end() , bbgnt);

  /*if bbgnt already exists, erase the old information and add the new one*/
  if(bbgnt_list_iter != bbgnt_list.end())
  {
   bbgnt_list.erase(bbgnt_list_iter);
   bbgnt_list.push_back(bbgnt);

  }

  /*else add the new bbgnt to the list */
  else
  {
   bbgnt_list.push_back(bbgnt);
   size_of_list=size_of_list+1;
  }


}


/***************************************************************
 function name: BBagent_Participants::agent_ask_bwd
 return value:int(0 or 1)
 arguments:a BBagent object,his neighbour node id,the bandwidth,
          the start and the stop time of the request
 mission:asks the list if a BBagent object bbgnt has availiable
         bwd bandwith on the connection with his neighbour n_id.
	 If the list does not have bbgnt in his records,the
	 function returns 1.If bbgnt exists but "answers" that
	 he does not have the availiable bandwidth the function
	 returns 1.
	 Else the answer is positive and returns 0.
****************************************************************/
int BBagent_Participants::agent_ask_bwd(BBagent& bbgnt,int n_id,int bwd,int start_time,int stop_time)
{

   list<BBagent>::iterator bbgnt_list_iter;/* an iterator for bbgnt_list */

   /*find in the list the BBagent bbgnt*/
   /*this BBagent is found according to his node id and only */
   bbgnt_list_iter = find(bbgnt_list.begin(), bbgnt_list.end() , bbgnt);

   /* if the list does not have bbgnt returns 1*/
   if(bbgnt_list_iter== bbgnt_list.end())
   {
     return 1;
   }

   /* if the list has bbgnt but bbgnt has not the availiable bwd
      returns 1 */
   if(bbgnt_list_iter->Ask_bwd(n_id,bwd,start_time,stop_time)==1)
   {
    return 1;
   }
   /* else the answer is positive and returns 0 */
   else
   {
    return 0;
   }

}


/*******************************************************************
 function name: BBagent_Participants::agent_remove_bwd
 return value:void
 arguments:a BBagent object,his neighbour node id,the bandwidth,
           the start and the stop time of the request
 mission:from BBagent bbgnt removes bandwidth bwd on the connection
         with his neighbour with node id==n_id
********************************************************************/
void BBagent_Participants::agent_remove_bwd(BBagent& bbgnt,int n_id,int bwd,int start_time,int stop_time)
{
   list<BBagent>::iterator bbgnt_list_iter;/* an iterator for bbgnt_list */

   /*find in the list the BBagent bbgnt*/
   /*this BBagent is found according to his node id and only */
   bbgnt_list_iter = find(bbgnt_list.begin(), bbgnt_list.end() , bbgnt);

   /*for the  BBagent bbgnt ,remove the bandwith bwd from the
     bandwidth of the connection with the neighbour agent
     with node id == n_id*/
   bbgnt_list_iter->Fix_nghbr(n_id,bwd,start_time,stop_time);

   
}

