/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
               Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/


/* Headers */

/* add this header as a header of ns  */
#ifndef ns_BBagent_Participants_h
#define ns_BBagent_Participants_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include "route.h"
#include "node.h"

/**************************************************************
 header name:BBagent.h
 mission:header file where we find and take the objects of the
         class BBagent, which we send as arguments to the
	 control functions of the list of the class
	 BBagent_participants
***************************************************************/
#include "BBagent.h"
#include <list>

#include <algorithm>

#include <cstdlib>
using namespace std;

/********************************************************************
 class name:BBagent_Participants
 mission:An instance(object) of this class has two(2) members,a list
         of BBagent instances and a variable which holds the
	 magnitude of the list or else the number of BBagents in
	 our domain.This instance takes the role of a database
	 which a BBbase agent asks and informs about
	  every change of the existed situation of our domain.
*********************************************************************/
class BBagent_Participants
{
public:
	/* constructor */
	BBagent_Participants();

	/* destructor */
	~BBagent_Participants(){}

	/* access functions */
	int GetSize_of_list() const ;
	void SetSize_of_list(int);

	/* list control functions */
	void add_to_list(BBagent& bbgnt); /* adds to list the BBagent object bbgnt */
	int remove_from_list(BBagent& bbgnt);/* removes from list the BBagent object bbgnt */
	void clear_list();                  /* clears the list from all the BBagent objects */
	void update_list(BBagent& bbgnt); /*updates the list with the BBagent object bbgnt */
	int agent_ask_bwd(BBagent& bbgnt,int n_id,int bwd,int start_time,int stop_time);/*ask list if bbgnt has for
							     his neighbour n_id availiable bwd */
	void agent_remove_bwd(BBagent& bbgnt,int n_id,int bwd,int start_time,int stop_time);/*from bbgnt removes bwd of
								connection with n_id */

protected:
	list<BBagent> bbgnt_list; /*list of BBagent objects which is under the control of
				   the   class BBagent_Participants */
	int size_of_list;  /*number which holds the magnitude of the list or else
	                     the number of BBagents in our domain*/
};

#endif // ns_BBagent_Participants_h
