 /***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/
/* Headers */

/* add this header as a header of ns  */
#ifndef ns_BBedge_h
#define ns_BBedge_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include "route.h"
#include "node.h"

#include "List_Requests.h"
#include "BBagent_Participants.h"

#include <stdio.h>

#include <list>

#include <algorithm>
using namespace std;

/****************************************
struct name:hdr_bbe
mission:header of the packet(bbe packet)
        that a BBedge Agent sends to a
	BBbase Agent
*****************************************/
struct hdr_bbe
{
     /* char ret;*/
     /*	 double send_time;*/
     /*  int p_size;*/

    int type;   /* the type of packet, for example REQUEST */
    int answer; /* POSITIVE or NEGATIVE answer to a question of BBbase */
    int bndw_request; /*the magnitude of the bandwidth request*/
    nsaddr_t sender;  /*address of the node(sender) who sends the request for bandwidth */
    nsaddr_t endnode; /*address of the last node of the request */
    /********************************************
     variable name:hop_num
     mission:counts the number of hops that
     	     the request has visited except for
	     the BBbase Agent
     *******************************************/
    int hop_num;
    /******************************************
    variable name:dscp
    mission:every application has a unique
    	    dscp number.The packet are policed
	    according to this number
    *******************************************/
    int dscp;

    double start_time;/*when the allocation of the bandwith begins */
    double stop_time; /*when the allocation of the bandwith ends */

    int status;    /* the status of the node that sends the packet*/
    		   /* status DOWN ,the node does not work*/
                   /* status ACTIVE the node works*/


    /* Header access methods */
    static int offset_; /* required by PacketHeaderManager */
    inline static int& offset() { return offset_; }
    inline static hdr_bbe* access(const Packet* p)
    {
    	return (hdr_bbe*) p->access(offset_);
    }

};


/****************************************
struct name:hdr_bbb
mission:header of the packet(bbb packet)
        that a BBbase Agent sends to a
	BBedge Agent
*****************************************/
struct hdr_bbb
 {
    /* char ret;*/
    /*	 double send_time;*/
    /*  int p_size;*/

    int type;   /* the type of packet, for example REQUEST */
    int answer; /* POSITIVE or NEGATIVE answer to a question of BBbase */
    int bndw_request; /*the magnitude of the bandwidth request*/
    nsaddr_t sender;  /*address of the node(sender) who sends the request for bandwidth */
    nsaddr_t endnode; /*address of the last node of the request */
    /****************************************
     variable name:hop_num
     mission:counts the number of hops that
     	     the request has visited except for
	     the BBbase Agent
     ******************************************/
    int hop_num;
    /*****************************************
    variable name:dscp
    mission:every application has a unique
    	    dscp number.The packet are policed
	    according to this number
    ******************************************/
    int dscp;

    double start_time;/*when the allocation of the bandwith begins */
    double stop_time; /*when the allocation of the bandwith ends */

    int status;    /* the status of the node that sends the packet*/
    		   /* status DOWN ,the node does not work*/
                   /* status ACTIVE the node works*/


    /* Header access methods*/
    static int offset_; /* required by PacketHeaderManager */
    inline static int& offset() { return offset_; }
    inline static hdr_bbb* access(const Packet* p)
    {
      return (hdr_bbb*) p->access(offset_);
    }

};


/*****************************************************
 class name:BBedgeAgent
 mission:creates a new Agent which has three roles.
 	 First to ask for bandwidth from the BBbase.
	 Second to inform BBbase for his condition
	 and third to hold all the bandwidth
	 information as regards his connections
	 with his neighbours.
******************************************************/
class BBedgeAgent : public Agent {
public:
	/*constructor*/
	BBedgeAgent();

	/* class functions */
	virtual int command(int argc, const char*const* argv);
        virtual void recv(Packet*, Handler*);
        int sendto(nsaddr_t,int);
        int sendto(nsaddr_t,int,double,double);
        int inform(int,int);


protected:
    list<neighbour> nghbr_list; /* list of structs 'neighbour' */
};

#endif // ns_BBedge_h
