/***************************************************************************
  Research Academic Computer Technology Institute,
  61 Riga Feraiou Str,26221 Patras ,Greece &
  Department of Computer Engineering and Informatics,
  University of Patras, 26500 Rion ,Patras,Greece

  Research Unit 6

  project name:Bandwidth Broker
  project team:Christos Bouras
               Dimitris Primpas
	       Kostas Stamos
	       Ioannis Pappas

  date:20 January 2005
  updated:no
  contact:bouras@cti.gr,primpas@cti.gr,stamos@cti.gr,pappasj@ceid.upatras.gr

*****************************************************************************/

/* Headers */

/* add this header as a header of ns  */
#ifndef ns_List_Requests_h
#define ns_List_Requests_h

#include "agent.h"
#include "tclcl.h"
#include "packet.h"
#include "address.h"
#include "ip.h"
#include "route.h"
#include "node.h"

/**************************************************************
 header name:Request.h
 mission:header file where we find and take the objects of the
         class Request, which we send as arguments to the
	 control functions of the list of the class
	List_Requests
***************************************************************/
#include "Request.h"

#include <list.h>


/********************************************************************
 class name:List_Requests
 mission:An instance(object) of this class has two(2) members,a list
         of Request instances and a variable which holds the
	 magnitude of the list or else the number of Requests in
	 our domain.This instance takes the role of a database which
	 a BBbase agent asks and informs about every change of the
	 status of the existed requests for bandwidth, in our domain.
*********************************************************************/
class List_Requests
{
public:
	/* constructor */
	List_Requests();

	/* destructor */
	~List_Requests(){}

	/* access functions */
	int GetSize_of_list() const ;
	void SetSize_of_list(int);

	/* list control functions */
	void add_to_list(Request& demand); /* adds to list the Request object demand */
	void remove_from_list(Request& demand); /* removes from the list the Request object demand */
	Request get_cur_rqst();   /*returns the Request object which is added last into the list*/
	Request get_first_rqst(); /*returns the Request object which is now first into the list*/

protected:
	list<Request> rqst_list; /*list of Request objects which is under the control of
				   the   class  List_Requests*/
	int size_of_list;  /*number which holds the magnitude of the list or else
	                     the number of Requests for bandwidth in our domain*/
};

#endif // ns_List_Requests_h
