#include <stdio.h>

#include <stdlib.h>

#include <math.h>

#include "trafgen.h"

int count=0;

double Alfa, Gamma, A, L, // # of packet arrivals per sec

		M, // # of FRPs

		rate_, // transmission rate in Kbps

		H; // hurst parameter

long Seed;

double S=0.0; 	// saves the time of the previous arrival...

struct node *saver; 	// saves the first node of the linked list for the next time...

struct node{

	int processno;

	double time;

	struct node *next;

};

struct node *head=NULL;

class SupFRP_Traffic : public TrafficGenerator {

public:

SupFRP_Traffic(int);

virtual double next_interval(int&);

int on() { return on_;}

struct node *Insert(struct node *HList, int newprocess, double newtime)

{

	struct node *save, *temp1, *temp2;

	save=(struct node*)malloc(sizeof(struct node));

	save->time = newtime;

	save->processno = newprocess;

	if(HList==NULL){

		HList=save;

		HList->next=NULL;

	}

	else if (newtime<=HList->time){

		save->next=HList;

		HList=save;

	}

	else{

		temp2=HList;

		while((temp2->time<=newtime)&&(temp2->next!=NULL)){

			temp1=temp2;

			temp2=temp2->next;

		}

		if (temp2->time<=newtime){

			temp1=temp2;

			temp2=temp2->next;

		}

		temp1->next=save;

		save->next=temp2;

	}

	return(HList);

}



struct node *GetMin(struct node *HList, struct node ** DeletedNode)

{

	(*DeletedNode)=HList;

	return(HList->next);

}



double GenerateTime2(double U)

{

	if (U>=exp(-Gamma))

	return(-(1/Gamma)*A*log(U));

	else

	return (exp((double)-1)*A*exp((double)((-1/Gamma)*log(U))));

}



double GenerateTime(double U)

{

	double V;

	V=(1+(Gamma-1)*exp((double)Gamma))*U/Gamma;

	if (V>=1)

	return(-(1/Gamma)*A*log(U*(Gamma*V-1)/(Gamma*V-U)));

	else

	return (A*exp((double)((1/(1-Gamma))*log(V))));

}



double SupFRP(void)

{

	int j;

	double Taoj;

	double diff=0.0;

	if (count == 0) {

		for(j=1;j<=M;j++) {

			Taoj = GenerateTime(drand48());

			head = Insert(head,j,Taoj);

		}

		head = GetMin(head,&saver);

		diff = saver->time-S;

		S = saver->time;

		count++;

	} else {

		Taoj = GenerateTime2(drand48());

		saver->time += Taoj;

		head = Insert(head,saver->processno,saver->time);

		free(saver); head = GetMin(head,&saver);

		diff = saver->time-S;

		S = saver->time;

	}

	return (diff);

}



protected:

	void init();

	int on_;


};



SupFRP_Traffic::SupFRP_Traffic(int s)

{

	bind("rate_", &rate_);

	bind("packet_size_", &size_);

	bind("FRPs_", &M);

	bind("hurst_", &H);

	size_=s;

}



void SupFRP_Traffic::init()

{

	on_ = 0;

	Seed = 12351;

	srand48(Seed);



	L = (double)(rate_*1000)/(double)(8*size_); // find packet rate as packets/sec

	Alfa = (2*(double)H-1);

	Gamma = (2-Alfa);

	A = ((M*Gamma)/(L*(1+exp(-Gamma)/(Gamma-1))));

	if (agent_)

		agent_->set_pkttype(PT_wwwUDP);
}



double SupFRP_Traffic::next_interval(int& size)

{

	double t = SupFRP();

	on_ = 1;

	size = size_;

	return(t);

}



static class SupFRPTrafficClass : public TclClass {

	public:

	SupFRPTrafficClass() : TclClass("Application/Traffic/SupFRP") {}

	TclObject* create(int args, const char*const* argv) {

		return (new SupFRP_Traffic(atoi(argv[4])));
	}	

} class_SupFRP_traffic;
